
import lasagne
from theano import tensor as T

class lasagne_bilinear_layer(lasagne.layers.MergeLayer):
    
    def __init__(self, incoming, num_units, **kwargs):
        super(lasagne_bilinear_layer, self).__init__(incoming, **kwargs)

        self.W = self.add_param(lasagne.init.Normal(0.1), (num_units, num_units),
                   name="W")

    def get_output_for(self, inputs, **kwargs):
        emb1 = inputs[0]
        emb2 = inputs[1]
        return T.sum(emb1 * T.dot(emb2, self.W))

    def get_output_shape_for(self, input_shape):
        #print input_shape
        return input_shape[0]